function writecsv(filename, all, allColumns, commaSeparated)
fileID = fopen(filename, 'w', 'native', 'UTF-8');

for j = 1 : length(allColumns)
    if j > 1
        if commaSeparated
            fprintf(fileID, ',');
        else
            fprintf(fileID, '\t');
        end
    end
    fprintf(fileID, allColumns{j});
end

fprintf(fileID, '\n');

    for i = 1 : size(all,1)
        for j = 1 : size(all,2)
            if j > 1
                if commaSeparated
                    fprintf(fileID, ',');
                else
                    fprintf(fileID, '\t');
                end
            end
            if isnumeric(all{i,j})
                if isnan(all{i,j})
                    fprintf(fileID, ' ');
                else
                    fprintf(fileID, num2str(all{i,j}));
                end
            else
                text = all{i,j};
                text = strrep(text, '"', '''''');
                text = regexprep(text, ' +', ' ');
                text = strtrim(text);
                if isempty(text)
                    text = ' ';
                else
                    if commaSeparated
                        text = ['"' text '"'];
                    end
                end
                fprintf(fileID, text);
            end
        end
        fprintf(fileID, '\n');
    end
    
fclose(fileID);
end
